package thkoeln.archilab.ecommerce.domainprimitives;
import java.io.Serializable;

import javax.persistence.Embeddable;

import lombok.EqualsAndHashCode;
import lombok.NoArgsConstructor;
import thkoeln.archilab.ecommerce.ShopException;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.EmailAddressType;


@EqualsAndHashCode
@NoArgsConstructor
public class EmailAddress implements EmailAddressType, Serializable { //Experiment wise i tried to use chatgpt but i forgot to make a video

    //private String identifier;
    //private String domain;

    //@Column(unique = true, nullable = false)

    private String emailAddress;

    /*private EmailAddress(String identifier, String domain) {
        this.identifier = identifier;
        this.domain = domain;
    }*/

    public EmailAddress(String emailAddress) {
        validateAndSplitEmail(emailAddress);
        this.emailAddress = emailAddress;
        //this.identifier = parts[0];
       // this.domain = parts[1];
    }

    //this below completly contradicts DPs characteristics
    /*public void setEmailAddress(String emailAddress){
        String[] parts = validateAndSplitEmail(emailAddress);
        this.emailAddress = emailAddress;
    }*/

    @Override
    public String toString() {
       // return identifier + "@" + domain;
       return this.emailAddress;
    }

    @Override
    public EmailAddressType sameIdentifyerDifferentDomain(String domainString) throws ShopException {
        if (domainString == null) {
            throw new ShopException("Domain string is null.");
        }
        String[] mailParts = validateAndSplitEmail(this.emailAddress);

        String newEmail = mailParts[0] + "@" + domainString;

        validateAndSplitEmail(newEmail);
        return of(newEmail);
    }

    @Override
    public EmailAddressType sameDomainDifferentIdentifyer(String identifyerString) throws ShopException {
        if (identifyerString == null) {
            throw new ShopException("Identifier string cannot be null.");
        }
        String[] mailParts = validateAndSplitEmail(this.emailAddress);

        String newEmail = identifyerString + "@" + mailParts[1];
        return of(newEmail);
    }

    public static EmailAddressType of(String emailAddressAsString) throws ShopException {
        //String[] parts = validateAndSplitEmail(emailAddressAsString);

        return new EmailAddress(emailAddressAsString);
    }


    private static String[] validateAndSplitEmail(String emailAddressAsString) throws ShopException {

        if (emailAddressAsString == null) {
            throw new ShopException("Email address string is null.");
        }

        String[] mailParts = emailAddressAsString.split("@");
        if (mailParts.length != 2) {
            throw new ShopException("Wrong email pattern");
        }

        String identifier = mailParts[0];
        String domain = mailParts[1];

        if (identifier.isEmpty() || domain.isEmpty() || !identifier.matches("[A-Za-z0-9\\.]+") || !domain.matches("[A-Za-z0-9\\.]+") || identifier.contains("..") || domain.contains("..") || !domain.endsWith(".de") && !domain.endsWith(".at") && !domain.endsWith(".ch") && !domain.endsWith(".com") && !domain.endsWith(".org")) {
            throw new ShopException("Wrong email pattern");
        }

        return mailParts;
    }

}