package thkoeln.archilab.ecommerce.solution.depot.domain.entities;

import javax.persistence.ManyToOne;

import java.awt.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.UUID;

import javax.persistence.CascadeType;
import javax.persistence.ElementCollection;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import thkoeln.archilab.ecommerce.domainprimitives.PersonalAddress;
import thkoeln.archilab.ecommerce.solution.order.domain.valueObjects.orderPart.domain.OrderPart;
import thkoeln.archilab.ecommerce.solution.product.domain.entities.Product;

@Entity
@Getter
@Setter
//@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode
public class Depot {
    @Id
    private UUID depotId;

    @Embedded
    private PersonalAddress address;

    String name;

     @ElementCollection( targetClass = StockLevel.class, fetch = FetchType.EAGER)     //this instead embedded cause 1toMany Relation 
    private List<StockLevel> stockLevels = new ArrayList<StockLevel>();   //product+stock of this depot

    
    public StockLevel findProductInStock(UUID productId){

        for (StockLevel stockLevel : this.stockLevels) {
            if(stockLevel.getProduct().getProductId().equals(productId)) return stockLevel;
        }
        return null;
    }

    public void addOrUpdateStockLevels(StockLevel stocklevel){

        for (StockLevel stockLevelThis : this.getStockLevels()) {
            if(stockLevelThis.getProduct().equals(stocklevel.getProduct())) {
                stockLevelThis.setStock(stocklevel.getStock());
                return;
            }
        }
        this.getStockLevels().add(stocklevel);



        //return this.stockLevels;
    }
}
