package thkoeln.archilab.ecommerce.solution.order.domain;

//import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
//import lombok.NoArgsConstructor;
import lombok.Setter;
import thkoeln.archilab.ecommerce.solution.order.domain.valueObjects.orderPart.domain.OrderPart;
import thkoeln.archilab.ecommerce.solution.user.domain.entities.User;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.MoneyType;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import javax.persistence.*;

@Entity
@Getter
@Setter
@Table(name = "\"order\"")
@NoArgsConstructor
public class Order {

   /*  public enum OrderStatus {
        RESERVED,
        PURCHASED,
        PAID,
        DELIVERED
    }
    
    
  
    private LocalDateTime lastChange;
    private OrderStatus status; */ 

    @Id
    private UUID orderId;

    @ManyToOne
    //@JoinColumn(name = "emailaddress")
    private User user; 

    @ElementCollection( targetClass = OrderPart.class, fetch = FetchType.EAGER)     //this instead embedded cause 1toMany Relation

    private List<OrderPart> orderParts;

    /* @OneToMany(mappedBy = "order", cascade = CascadeType.ALL, fetch = FetchType.LAZY)
    private List<OrderPart> orderParts = new ArrayList<>(); */ 


    public Order(User user, List<OrderPart> orderParts) {  
        this.user = user;
       // this.lastChange = LocalDateTime.now();
       // status = OrderStatus.DELIVERED;

        this.orderParts = orderParts;
        orderId = UUID.randomUUID();
    }


    public MoneyType getOrderTotalPrice(){ 
        MoneyType totalPrice = null; 

        for( OrderPart orderPart : orderParts){
            if(totalPrice == null){
                totalPrice = orderPart.getProduct().getSellingPrice().multiplyBy(orderPart.getQuantity());
            }else{
                totalPrice = totalPrice.add(orderPart.getProduct().getSellingPrice().multiplyBy(orderPart.getQuantity()));
            }
        }

        return totalPrice;
    }


}