package thkoeln.archilab.ecommerce.solution.order.domain;

import java.util.List;
import java.util.Optional;
import java.util.UUID;
import org.springframework.data.repository.CrudRepository;

import thkoeln.archilab.ecommerce.domainprimitives.EmailAddress;
import thkoeln.archilab.ecommerce.solution.user.domain.entities.User;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.EmailAddressType;

public interface OrderRepository extends CrudRepository<Order, UUID>{

    //Order findByUser_EmailAddressAndStatus(String clientEmailAddress, Order.OrderStatus state);   //Sure it doesnt return list cause multiple orders could be delivered 
    //List<Order> findByUserEmailAddressAndStatus(EmailAddress clientEmailAddress, Order.OrderStatus state);
    //but only 1 can be reserved 
    
    //OrderPart findByUser_EmailAndProduct_ProductId(String userEmail, UUID productId);
    //OrderPart findByUser_EmailAndOrderParts_Product_ProductId(String userEmail, UUID productId);
    //List<Order> findByStatus(Order.OrderStatus status);     //this doesnt work ffs





    List<Order> findByUser(User user);
    //List<Order> findByUserEmailAddress(EmailAddress userEmail);

    Optional<Order> findByOrderId(UUID orderId);

    List<Order> findAll();  
}
