package thkoeln.archilab.ecommerce.solution.product.domain.entities;
 
import java.util.UUID;

import javax.persistence.Entity;
import javax.persistence.Id;

import lombok.AllArgsConstructor;
import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import thkoeln.archilab.ecommerce.domainprimitives.Money;
//import thkoeln.archilab.ecommerce.solution.product.application.controllers.OrderProductChecker;
//import thkoeln.archilab.ecommerce.solution.product.application.controllers.ShoppingCartProductChecker;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.MoneyType;



@Entity
@Getter
@Setter
//@AllArgsConstructor
@NoArgsConstructor
@EqualsAndHashCode
public class Product {
 
    @Id
    private UUID productId;
    private String name;    //duplicate names can exist so name is not id
    private String description;
    private Float size;    
    private Money purchasePrice;  
    private Money sellingPrice;   
    private int totalStock;   

    public Product(UUID productId, String name, String description, Float size, MoneyType purchasePrice, MoneyType sellingPrice){   //, int stock
        this.productId = productId;
        this.name = name;
        this.description = description;
        this.size = size;
        this.purchasePrice = (Money)purchasePrice;
        this.sellingPrice = (Money)sellingPrice; 
    }


/*
    public boolean canBeDeletedFromOrders(OrderProductChecker orderProductChecker) {
        if (orderProductChecker.isProductInOrder(productId)) {
            return false;
        }
        
        return true;
    }

    public boolean canBeDeletedFromCarts(ShoppingCartProductChecker shoppingCartProductChecker) {
        if (shoppingCartProductChecker.isProductInShoppingCart(productId)) {
            return false;
        }
        
        return true;
    } */
 
}
