package thkoeln.archilab.ecommerce.solution.shoppingcart.application;

import org.springframework.stereotype.Component;
import thkoeln.archilab.ecommerce.domainprimitives.EmailAddress;
import thkoeln.archilab.ecommerce.domainprimitives.Money;
import thkoeln.archilab.ecommerce.solution.order.domain.valueObjects.orderPart.domain.OrderPart;
import thkoeln.archilab.ecommerce.solution.shoppingcart.domain.entities.ShoppingCart;
import thkoeln.archilab.ecommerce.solution.user.application.UserDto;
import thkoeln.archilab.ecommerce.solution.user.application.exceptions.UserCreationException;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.UUID;

import org.hibernate.cfg.NotYetImplementedException;
import org.modelmapper.ModelMapper;


@Component
public final class ShoppingCartDtoMapperHelper {

    private static ModelMapper modelMapper = new ModelMapper();

    public static ShoppingCartDto mapToDto(ShoppingCart shoppingCart){
       
        String totalSellingPrice ="";
    if(shoppingCart.getCartTotalPrice() == null){
        totalSellingPrice = "0.00 €";    //lokal mit , und online mit .
    }else{

        Money money = (Money)shoppingCart.getCartTotalPrice();
        totalSellingPrice = money.toMoneyString();

    }
     
    

        List<CartPositionDto> shoppingCartPositions = new ArrayList<CartPositionDto>();
        for (OrderPart part : shoppingCart.getCartItems()) {
            if(part.getQuantity() > 0){
                CartPositionDto pos = new CartPositionDto(part.getProduct().getProductId(), part.getQuantity());
                shoppingCartPositions.add(pos);
            }
            
        }

        
        return new ShoppingCartDto(
            shoppingCart.getId(),
            totalSellingPrice,
            shoppingCartPositions 
        );

    }


    public static ShoppingCart mapToEntity(ShoppingCartDto userDto) throws UserCreationException 
    {
        throw new NotYetImplementedException("Users mapToEntity");
       /*  ShoppingCart shoppingCart = new ShoppingCart();
        modelMapper.map(userDto, shoppingCart);
        return shoppingCart;*/
    }
    
}
