package thkoeln.archilab.ecommerce.solution.shoppingcart.domain.entities;


//import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
//import lombok.NoArgsConstructor;
import lombok.Setter;
import thkoeln.archilab.ecommerce.domainprimitives.EmailAddress;
import thkoeln.archilab.ecommerce.solution.order.domain.valueObjects.orderPart.domain.OrderPart;
import thkoeln.archilab.ecommerce.solution.user.domain.entities.User;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.MoneyType;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

import javax.persistence.*;

@Entity
@Getter
@Setter
@NoArgsConstructor
public class ShoppingCart {

    @Id
    private UUID id;

   // @Id
   // private EmailAddress id;

    @OneToOne 
    //@JoinColumn(name = "emailaddress")
    //@MapsId
    private User user;  


    //@Embedded
    @ElementCollection( targetClass = OrderPart.class, fetch = FetchType.EAGER)     //this instead embedded cause 1toMany Relation
    private List<OrderPart> cartItems;     //alternativ muss ich orderpart referenz auf


    

    public ShoppingCart(User user, OrderPart orderPart) {  

        this.id = UUID.randomUUID();

        this.user = user;

        this.cartItems = new ArrayList<OrderPart>();
        this.cartItems.add(orderPart);
       // id = user.getEmailAddress();
    }

    public ShoppingCart(User user) {  
        this.id = UUID.randomUUID();
        this.user = user;
        //id = user.getEmailAddress();

        this.cartItems = new ArrayList<OrderPart>();
    }



    public MoneyType getCartTotalPrice(){
        MoneyType totalPrice = null;
        for( OrderPart orderPart : cartItems){
            if(totalPrice == null){
                totalPrice = orderPart.getProduct().getSellingPrice().multiplyBy(orderPart.getQuantity());
            }else{
                totalPrice = totalPrice.add(orderPart.getProduct().getSellingPrice().multiplyBy(orderPart.getQuantity()));
            }
        }

        return totalPrice;
    }

}