package thkoeln.archilab.ecommerce.solution.user.domain.entities;
import java.util.UUID;

import javax.persistence.*;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import thkoeln.archilab.ecommerce.domainprimitives.EmailAddress;
import thkoeln.archilab.ecommerce.domainprimitives.PersonalAddress;
import thkoeln.archilab.ecommerce.usecases.UserType;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.EmailAddressType;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.PersonalAddressType;


@Entity
@Getter
@Setter
@NoArgsConstructor
@EqualsAndHashCode
public class User implements UserType {

    @Id
    private UUID id;

    private String name;

    @Column(unique=true)
    private EmailAddress emailAddress;

    @Embedded
    private PersonalAddress address;

    

    
    public User(String name, EmailAddress emailAddress, PersonalAddress address, UUID id) {
        this.name = name;
        this.emailAddress = emailAddress;
        this.address = address;
        this.id = id;
    }


    @Override
    public PersonalAddressType getPersonalAddress() {
        return this.address;
    }
    
}