package thkoeln.archilab.ecommerce.usecases;

import thkoeln.archilab.ecommerce.ShopException;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.EmailAddressType;

import java.util.Map;
import java.util.UUID;

/**
 * This interface contains methods needed in the context of the order history of a user.
 */
public interface OrderUseCases {
    /**
     * Returns a map showing which products have been bought by a user, and how many of each product
     *
     * @param userEmailAddress
     * @return the order history of the user (map is empty if the user has not bought anything yet)
     * @throws ShopException if
     *      - the email address is null
     *      - the user with the given email address does not exist
     */
    public Map<UUID, Integer> getOrderHistory( EmailAddressType userEmailAddress );



    /**
     * Deletes all orders in the system
     */
    public void deleteAllOrders();
}
