package thkoeln.archilab.ecommerce.usecases.masterdata;

import lombok.Setter;
import thkoeln.archilab.ecommerce.usecases.UserType;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.EmailAddressType;
import thkoeln.archilab.ecommerce.usecases.domainprimitivetypes.PersonalAddressType;

import java.util.Objects;

@Setter
public class MockUser implements UserType {
    private String name;
    private EmailAddressType emailAddress;
    private PersonalAddressType personalAddress;


    public MockUser( String name, EmailAddressType emailAddress, PersonalAddressType personalAddress) {
        this.name = name;
        this.emailAddress = emailAddress;
        this.personalAddress = personalAddress;
    }

    @Override
    public String getName() {
        return name;
    }

    @Override
    public EmailAddressType getEmailAddress() {
        return emailAddress;
    }

    @Override
    public PersonalAddressType getPersonalAddress() {
        return personalAddress;
    }

    @Override
    public boolean equals( Object o ) {
        if ( this == o ) return true;
        if ( !( o instanceof MockUser ) ) return false;
        MockUser that = (MockUser) o;
        return Objects.equals( getName(), that.getName() ) && Objects.equals( emailAddress, that.emailAddress ) && Objects.equals( personalAddress, that.personalAddress );
    }

    @Override
    public int hashCode() {
        return Objects.hash( getName(), emailAddress, personalAddress );
    }
}
