package thkoeln.archilab.ecommerce.usecases.masterdata;

import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import thkoeln.archilab.ecommerce.usecases.*;

/**
 * Removes everything :-)
 */
@Service
@Slf4j
public class Purgatory {
    @Autowired
    private UserRegistrationUseCases userRegistrationUseCases;
    @Autowired
    private ShoppingCartUseCases shoppingCartUseCases;
    @Autowired
    private OrderUseCases orderUseCases;
    @Autowired
    private ProductCatalogUseCases productCatalogUseCases;
    @Autowired
    private DepotUseCases depotUseCases;
    @Autowired
    private ShipmentUnitUseCases shipmentUnitUseCases;

    public void deleteEverything() {
        log.info("Purgatory: Deleting everything...");
        shipmentUnitUseCases.deleteAllShipmentUnits();
        orderUseCases.deleteAllOrders();
        shoppingCartUseCases.emptyAllShoppingCarts();
        depotUseCases.deleteAllDepots();
        userRegistrationUseCases.deleteAllUsers();
        productCatalogUseCases.deleteProductCatalog();
    }
}
